unit imagefxfrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_vglayer, dx_objects;

type
  TForm11 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    SetupLayer: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Rectangle1: TvxRectangle;
    HudTrackBar1: TvxHudTrackBar;
    Label1: TvxLabel;
    Label2: TvxLabel;
    HudTrackBar2: TvxHudTrackBar;
    Label3: TvxLabel;
    HudTrackBar3: TvxHudTrackBar;
    HudButton1: TvxHudButton;
    PreviewLayer: TdxObjectLayer;
    Root4: TvxLayout;
    PreviewLayout: TvxLayout;
    Preview: TvxRectangle;
    ReflectionEffect1: TvxReflectionEffect;
    Label4: TvxLabel;
    CheckBox1: TvxCheckBox;
    CheckBox2: TvxCheckBox;
    CheckBox3: TvxCheckBox;
    CheckBox4: TvxCheckBox;
    HudButton2: TvxHudButton;
    SaveDialog1: TSaveDialog;
    procedure HudTrackBar1Change(Sender: TObject);
    procedure HudTrackBar2Change(Sender: TObject);
    procedure HudTrackBar3Change(Sender: TObject);
    procedure HudButton1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure HudButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form11: TForm11;

implementation

{$R *.dfm}


procedure TForm11.HudTrackBar1Change(Sender: TObject);
begin
  Preview.xRadius := HudTrackBar1.Value;
  Preview.yRadius := HudTrackBar1.Value;
end;

procedure TForm11.HudTrackBar2Change(Sender: TObject);
begin
  Preview.StrokeThickness := HudTrackBar2.Value;
end;

procedure TForm11.HudTrackBar3Change(Sender: TObject);
begin
  PreviewLayer.RotateAngle.Z := HudTrackBar3.Value;
end;

procedure TForm11.HudButton1Click(Sender: TObject);
begin
  vgBitmapEditor := TvxBitmapEditor.Create(Self);
  vgBitmapEditor.AssignFromBitmap(Preview.Fill.Bitmap.Bitmap);
  if vgBitmapEditor.ShowModal = mrOk then
  begin
    vgBitmapEditor.AssignToBitmap(Preview.Fill.Bitmap.Bitmap);
    // call SetBounds need to corect fit Preview in Layout1 - because Preview use vaFit align
    Preview.SetBounds(0, 0, Preview.Fill.Bitmap.Bitmap.Width, Preview.Fill.Bitmap.Bitmap.Height);
    // Update reflection
    Preview.UpdateEffects;
  end;
  vgBitmapEditor.Free;
end;

procedure TForm11.CheckBox1Change(Sender: TObject);
begin
  Preview.Corners := [];
  if CheckBox1.IsChecked then
    Preview.Corners := Preview.Corners + [vgCornerTopLeft];
  if CheckBox2.IsChecked then
    Preview.Corners := Preview.Corners + [vgCornerTopRight];
  if CheckBox3.IsChecked then
    Preview.Corners := Preview.Corners + [vgCornerBottomLeft];
  if CheckBox4.IsChecked then
    Preview.Corners := Preview.Corners + [vgCornerBottomRight];
  Preview.UpdateEffects;
end;

procedure TForm11.HudButton2Click(Sender: TObject);
var
  B: TvxBitmap;
  R: TvxRect;
begin
  if SaveDialog1.Execute then
  begin
    // get screen size of 3D Object
    R := PreviewLayer.ScreenBounds;
    // create TvxBitmap - TvxBitmap is a best for export because it not create any hardware resoruces
    B := TvxBitmap.Create(trunc(vgRectWidth(R)), trunc(vgRectHeight(R)));
    // render to TvxBitmap
    PreviewLayer.PaintToVxBitmap(B, B.Width, B.Height, $00000000{ Clear Color });
    // Save to file
    B.SaveToFile(SaveDialog1.FileName);
    // free resoruces
    B.Free;
  end;
end;

end.
